/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
import { SegmentGroup, type ISegmentLeaf } from "./mergeTreeNodes.js";
export declare class SegmentGroupCollection {
    private readonly segment;
    private readonly segmentGroups;
    constructor(segment: ISegmentLeaf);
    get size(): number;
    get empty(): boolean;
    enqueue(segmentGroup: SegmentGroup<ISegmentLeaf>): void;
    dequeue(): SegmentGroup<ISegmentLeaf> | undefined;
    remove?(segmentGroup: SegmentGroup<ISegmentLeaf>): boolean;
    pop?(): SegmentGroup<ISegmentLeaf> | undefined;
    copyTo(segmentGroups: SegmentGroupCollection): void;
    private enqueueOnCopy;
}
//# sourceMappingURL=segmentGroupCollection.d.ts.map